package io.fabric8.kubernetes.api.model;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link HostAlias} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractHostAliasAssert<S extends AbstractHostAliasAssert<S, A>, A extends HostAlias> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractHostAliasAssert}</code> to make assertions on actual HostAlias.
   * @param actual the HostAlias we want to make assertions on.
   */
  protected AbstractHostAliasAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual HostAlias we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property hostnames so that assertions can be done on it
   */
  public NavigationListAssert<String, org.assertj.core.api.StringAssert> hostnames()  {
    isNotNull();

    // return the assertion for the property
    AssertFactory<String, org.assertj.core.api.StringAssert> assertFactory = new AssertFactory<String, org.assertj.core.api.StringAssert>() {
      public org.assertj.core.api.StringAssert createAssert(String t) {
        return (org.assertj.core.api.StringAssert) assertThat(t);
      }
    };
    NavigationListAssert<String, org.assertj.core.api.StringAssert> answer = new NavigationListAssert<String, org.assertj.core.api.StringAssert>(actual.getHostnames(), assertFactory);
    answer.describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "hostnames"));
    return answer;
  }


  /**
   * Navigates to the property ip so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert ip()  {
    // check that actual HostAlias we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getIp()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "ip"));
  }


}
