package io.fabric8.kubernetes.api.model.apiextensions;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link CustomResourceDefinitionNames} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractCustomResourceDefinitionNamesAssert<S extends AbstractCustomResourceDefinitionNamesAssert<S, A>, A extends CustomResourceDefinitionNames> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractCustomResourceDefinitionNamesAssert}</code> to make assertions on actual CustomResourceDefinitionNames.
   * @param actual the CustomResourceDefinitionNames we want to make assertions on.
   */
  protected AbstractCustomResourceDefinitionNamesAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual CustomResourceDefinitionNames we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property kind so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert kind()  {
    // check that actual CustomResourceDefinitionNames we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getKind()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "kind"));
  }


  /**
   * Navigates to the property listKind so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert listKind()  {
    // check that actual CustomResourceDefinitionNames we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getListKind()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "listKind"));
  }


  /**
   * Navigates to the property plural so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert plural()  {
    // check that actual CustomResourceDefinitionNames we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getPlural()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "plural"));
  }


  /**
   * Navigates to the property shortNames so that assertions can be done on it
   */
  public NavigationListAssert<String, org.assertj.core.api.StringAssert> shortNames()  {
    isNotNull();

    // return the assertion for the property
    AssertFactory<String, org.assertj.core.api.StringAssert> assertFactory = new AssertFactory<String, org.assertj.core.api.StringAssert>() {
      public org.assertj.core.api.StringAssert createAssert(String t) {
        return (org.assertj.core.api.StringAssert) assertThat(t);
      }
    };
    NavigationListAssert<String, org.assertj.core.api.StringAssert> answer = new NavigationListAssert<String, org.assertj.core.api.StringAssert>(actual.getShortNames(), assertFactory);
    answer.describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "shortNames"));
    return answer;
  }


  /**
   * Navigates to the property singular so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert singular()  {
    // check that actual CustomResourceDefinitionNames we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getSingular()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "singular"));
  }


}
