package io.fabric8.kubernetes.api.model.extensions;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;
import org.assertj.core.util.Objects;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link HostPortRange} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractHostPortRangeAssert<S extends AbstractHostPortRangeAssert<S, A>, A extends HostPortRange> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractHostPortRangeAssert}</code> to make assertions on actual HostPortRange.
   * @param actual the HostPortRange we want to make assertions on.
   */
  protected AbstractHostPortRangeAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual HostPortRange we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Verifies that the actual HostPortRange's max is equal to the given one.
   * @param max the given max to compare the actual HostPortRange's max to.
   * @return this assertion object.
   * @throws AssertionError - if the actual HostPortRange's max is not equal to the given one.
   */
  public S hasMax(Integer max) {
    // check that actual HostPortRange we want to make assertions on is not null.
    isNotNull();

    // overrides the default error message with a more explicit one
    String assertjErrorMessage = "\nExpecting max of:\n  <%s>\nto be:\n  <%s>\nbut was:\n  <%s>";
    
    // null safe check
    Integer actualMax = actual.getMax();
    if (!Objects.areEqual(actualMax, max)) {
      failWithMessage(assertjErrorMessage, actual, max, actualMax);
    }

    // return the current assertion for method chaining
    return myself;
  }

  /**
   * Verifies that the actual HostPortRange's min is equal to the given one.
   * @param min the given min to compare the actual HostPortRange's min to.
   * @return this assertion object.
   * @throws AssertionError - if the actual HostPortRange's min is not equal to the given one.
   */
  public S hasMin(Integer min) {
    // check that actual HostPortRange we want to make assertions on is not null.
    isNotNull();

    // overrides the default error message with a more explicit one
    String assertjErrorMessage = "\nExpecting min of:\n  <%s>\nto be:\n  <%s>\nbut was:\n  <%s>";
    
    // null safe check
    Integer actualMin = actual.getMin();
    if (!Objects.areEqual(actualMin, min)) {
      failWithMessage(assertjErrorMessage, actual, min, actualMin);
    }

    // return the current assertion for method chaining
    return myself;
  }

}
