package io.fabric8.kubernetes.api.model.extensions;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link KubernetesRunAsUserStrategyOptions} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractKubernetesRunAsUserStrategyOptionsAssert<S extends AbstractKubernetesRunAsUserStrategyOptionsAssert<S, A>, A extends KubernetesRunAsUserStrategyOptions> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractKubernetesRunAsUserStrategyOptionsAssert}</code> to make assertions on actual KubernetesRunAsUserStrategyOptions.
   * @param actual the KubernetesRunAsUserStrategyOptions we want to make assertions on.
   */
  protected AbstractKubernetesRunAsUserStrategyOptionsAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual KubernetesRunAsUserStrategyOptions we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property ranges so that assertions can be done on it
   */
  public NavigationListAssert<IDRange, IDRangeAssert> ranges()  {
    isNotNull();

    // return the assertion for the property
    AssertFactory<IDRange, IDRangeAssert> assertFactory = new AssertFactory<IDRange, IDRangeAssert>() {
      public IDRangeAssert createAssert(IDRange t) {
        return (IDRangeAssert) assertThat(t);
      }
    };
    NavigationListAssert<IDRange, IDRangeAssert> answer = new NavigationListAssert<IDRange, IDRangeAssert>(actual.getRanges(), assertFactory);
    answer.describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "ranges"));
    return answer;
  }


  /**
   * Navigates to the property rule so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert rule()  {
    // check that actual KubernetesRunAsUserStrategyOptions we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getRule()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "rule"));
  }


}
