package io.fabric8.kubernetes.api.model.policy;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link PodDisruptionBudgetSpec} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractPodDisruptionBudgetSpecAssert<S extends AbstractPodDisruptionBudgetSpecAssert<S, A>, A extends PodDisruptionBudgetSpec> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractPodDisruptionBudgetSpecAssert}</code> to make assertions on actual PodDisruptionBudgetSpec.
   * @param actual the PodDisruptionBudgetSpec we want to make assertions on.
   */
  protected AbstractPodDisruptionBudgetSpecAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual PodDisruptionBudgetSpec we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property maxUnavailable so that assertions can be done on it
   */
  public io.fabric8.kubernetes.api.model.IntOrStringAssert maxUnavailable()  {
    // check that actual PodDisruptionBudgetSpec we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (io.fabric8.kubernetes.api.model.IntOrStringAssert) assertThat(actual.getMaxUnavailable()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "maxUnavailable"));
  }


  /**
   * Navigates to the property minAvailable so that assertions can be done on it
   */
  public io.fabric8.kubernetes.api.model.IntOrStringAssert minAvailable()  {
    // check that actual PodDisruptionBudgetSpec we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (io.fabric8.kubernetes.api.model.IntOrStringAssert) assertThat(actual.getMinAvailable()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "minAvailable"));
  }


  /**
   * Navigates to the property selector so that assertions can be done on it
   */
  public io.fabric8.kubernetes.api.model.LabelSelectorAssert selector()  {
    // check that actual PodDisruptionBudgetSpec we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (io.fabric8.kubernetes.api.model.LabelSelectorAssert) assertThat(actual.getSelector()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "selector"));
  }


}
