package io.fabric8.openshift.api.model;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link SourceBuildStrategy} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractSourceBuildStrategyAssert<S extends AbstractSourceBuildStrategyAssert<S, A>, A extends SourceBuildStrategy> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractSourceBuildStrategyAssert}</code> to make assertions on actual SourceBuildStrategy.
   * @param actual the SourceBuildStrategy we want to make assertions on.
   */
  protected AbstractSourceBuildStrategyAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual SourceBuildStrategy we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property env so that assertions can be done on it
   */
  public NavigationListAssert<io.fabric8.kubernetes.api.model.EnvVar, io.fabric8.kubernetes.api.model.EnvVarAssert> env()  {
    isNotNull();

    // return the assertion for the property
    AssertFactory<io.fabric8.kubernetes.api.model.EnvVar, io.fabric8.kubernetes.api.model.EnvVarAssert> assertFactory = new AssertFactory<io.fabric8.kubernetes.api.model.EnvVar, io.fabric8.kubernetes.api.model.EnvVarAssert>() {
      public io.fabric8.kubernetes.api.model.EnvVarAssert createAssert(io.fabric8.kubernetes.api.model.EnvVar t) {
        return (io.fabric8.kubernetes.api.model.EnvVarAssert) assertThat(t);
      }
    };
    NavigationListAssert<io.fabric8.kubernetes.api.model.EnvVar, io.fabric8.kubernetes.api.model.EnvVarAssert> answer = new NavigationListAssert<io.fabric8.kubernetes.api.model.EnvVar, io.fabric8.kubernetes.api.model.EnvVarAssert>(actual.getEnv(), assertFactory);
    answer.describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "env"));
    return answer;
  }


  /**
   * Navigates to the property forcePull so that assertions can be done on it
   */
  public org.assertj.core.api.BooleanAssert forcePull()  {
    // check that actual SourceBuildStrategy we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.BooleanAssert) assertThat(actual.getForcePull()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "forcePull"));
  }


  /**
   * Navigates to the property from so that assertions can be done on it
   */
  public io.fabric8.kubernetes.api.model.ObjectReferenceAssert from()  {
    // check that actual SourceBuildStrategy we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (io.fabric8.kubernetes.api.model.ObjectReferenceAssert) assertThat(actual.getFrom()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "from"));
  }


  /**
   * Navigates to the property incremental so that assertions can be done on it
   */
  public org.assertj.core.api.BooleanAssert incremental()  {
    // check that actual SourceBuildStrategy we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.BooleanAssert) assertThat(actual.getIncremental()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "incremental"));
  }


  /**
   * Navigates to the property pullSecret so that assertions can be done on it
   */
  public io.fabric8.kubernetes.api.model.LocalObjectReferenceAssert pullSecret()  {
    // check that actual SourceBuildStrategy we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (io.fabric8.kubernetes.api.model.LocalObjectReferenceAssert) assertThat(actual.getPullSecret()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "pullSecret"));
  }


  /**
   * Navigates to the property runtimeArtifacts so that assertions can be done on it
   */
  public NavigationListAssert<ImageSourcePath, ImageSourcePathAssert> runtimeArtifacts()  {
    isNotNull();

    // return the assertion for the property
    AssertFactory<ImageSourcePath, ImageSourcePathAssert> assertFactory = new AssertFactory<ImageSourcePath, ImageSourcePathAssert>() {
      public ImageSourcePathAssert createAssert(ImageSourcePath t) {
        return (ImageSourcePathAssert) assertThat(t);
      }
    };
    NavigationListAssert<ImageSourcePath, ImageSourcePathAssert> answer = new NavigationListAssert<ImageSourcePath, ImageSourcePathAssert>(actual.getRuntimeArtifacts(), assertFactory);
    answer.describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "runtimeArtifacts"));
    return answer;
  }


  /**
   * Navigates to the property runtimeImage so that assertions can be done on it
   */
  public io.fabric8.kubernetes.api.model.ObjectReferenceAssert runtimeImage()  {
    // check that actual SourceBuildStrategy we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (io.fabric8.kubernetes.api.model.ObjectReferenceAssert) assertThat(actual.getRuntimeImage()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "runtimeImage"));
  }


  /**
   * Navigates to the property scripts so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert scripts()  {
    // check that actual SourceBuildStrategy we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getScripts()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "scripts"));
  }


}
